package net.hoosiertransfer.teavm;

public class ReentrantLock {
    private Thread owner = null;
    private int lockCount = 0;

    public synchronized void lock() {
        Thread callingThread = Thread.currentThread();
        while (lockCount > 0 && owner != callingThread) {
            try {
                wait();
            } catch (InterruptedException e) {
                // Handle exception
            }
        }
        owner = callingThread;
        lockCount++;
    }

    public synchronized void unlock() {
        if (Thread.currentThread() == owner) {
            lockCount--;
            if (lockCount == 0) {
                owner = null;
                notify();
            }
        }
    }

    public synchronized boolean isHeldByCurrentThread() {
        return owner == Thread.currentThread();
    }

    public synchronized boolean tryLock() {
        Thread callingThread = Thread.currentThread();
        if (lockCount == 0 || owner == callingThread) {
            owner = callingThread;
            lockCount++;
            return true;
        } else {
            return false;
        }
    }
}